                        .model small
                        .code
                        .286

PUBLIC                  EXEC
PUBLIC                  parameter
PUBLIC                  program
PUBLIC                  Get_Dos_Var

Exec                    PROC
                        pusha
                        ; Ŀ
                        ;  Initialiseer EXEC parameter blok :                                                            
                        ;      - 00h   word    :   Segment of env. to copy for child process (0000h = copy callers env.) 
                        ;      - 02h  dword    :   pointer to command_tail to be copied into child PSP                   
                        ;      - 06h  dword    :   pointer to first FCB to be ....                                       
                        ;      - 0ah  dword    :   pointer to second FCB to be ....                                      
                        ; 
                        xor ax,ax
                        mov parmblk,ax                                  ; environment seg. ax = 0 dus copy callers env.
                                                                        ; BX : zie DISKBOX.INC
                        mov ax,bx                                       ; Wijzer naar Command_tail : Normaal is command_tail ...
                        mov parmblk+2,ax                                ; ... hetgene dat aan de dosprompt wordt in getikt ...
                        mov parmblk+4,ds                                ; ... (PSP:0080h), maar hier nemen we dat dus over !

                        mov ax,005ch                                    ; FCB1 is at PSP:005Ch
                        mov parmblk+6,ax
                        mov parmblk+8,es

                        mov ax,006ch                                    ; FCB2 is at PSP:006Ch
                        mov parmblk+10,ax
                        mov parmblk+12,es
                        ; Ŀ
                        ;  Roep dosfunktie "EXEC" - Load and/or execute program aan :    
                        ;          - AH    = 4Bh   :   EXEC-Funktie                      
                        ;          - AL    = 00h   :   Load and Execute                  
                        ;          - DS:DX =       :   ASCIIZ program name               
                        ;          - ES:BX =       :   Parameter blok (Zie boven)        
                        ; 
                        push ds                                         ; Point ES:BX to parmblk
                        pop es
                        mov bx,OFFSET parmblk
                        ; DS:DX wijst reeds naar ASCIIZ filespec        ; zie DISKBOX.INC
                        mov [keep_ss],ss                                ; Bewaar de stack pointer
                        mov [keep_sp],sp
                        mov [keep_es],es                                ; Bewaar ES oftewel PSPseg.
                        mov ax,4b00h                                    ; Execute child process
                        int 21h
                        mov Exec_error,word ptr 0                      ; 0 = geen error !
                        jnc Exec_sukses
                        mov Exec_error,ax                              ; AX = error code
Exec_sukses:
                        ; Ŀ
                        ;  Na het aan roepen van het 'child-proces' dienen ALLE registers terug gered te worden ! 
                        ; 
                        mov ax,@data
                        mov ds,ax                                       ; DS = datasegment
                        mov ss,[keep_ss]                                ; De registers terug redden !
                        mov sp,[keep_sp]
                        mov es,[keep_es]
                        popa
                        mov di,exec_error                               ; di = error code
                        RET
Exec                    ENDP

Get_Dos_Var             PROC
                        mov Naam,ax
                        mov Input,bx
                        mov Vlag,0h                                     ; Waarde gevonden !
                        push es
                        push ds
                        push cx
                        push dx
                        push si

                        mov dx,es:[2ch]                                 ; ES = Program Segment Prefix
                        mov es,dx                                       ; ES = Environment Space
                        mov si,0
l7:
                        cmp es:[si],byte ptr 0
                        jne l0
                        mov Vlag,0ffffh                                 ; Waarde NIET gevonden !
                        jmp get_end
l0:
                        mov dx,si
l1:
                        cmp es:[si],byte ptr "="
                        je  l2
                        inc si
                        jmp l1
l2:
                        inc si
                        mov de_waarde,si
                        mov cx,si
                        sub cx,dx                                       ; cx = lengte tot aan "="
                        mov si,dx                                       ; oude waarde !

                        push es
                        push ds

                        mov di,offset buffer
                        PUSH es
                        push ds
                        pop  es
                        POP  DS
                        rep movsb
                        dec cx
                        add di,cx
                        pop ds                                          ; hier is NU! : ES en DS gelijk !
                        mov es:[di],byte ptr 0
                        mov di,offset buffer
                        mov si,Naam
                        mov ax,121eh                                    ; DOS 3+ internal - Vgl van 2 strings. -
                        int 2fh                                         ; Supported by DR-DOS 5+
                        pop es
                        jne l8
                        mov si,de_waarde
                        mov di,Input
                        push ds
                        push es
                        pop  ds
                        pop  es
                        mov cx,40h
                        rep movsw
                        push ds
                        push es
                        pop  ds
                        pop  es
get_end:
                        pop si
                        pop dx
                        pop cx
                        pop ds
                        pop es
                        mov di,vlag
                        RET                                             ; einde routine
l8:
                        mov si,dx                                       ; oude waarde !
l5:
                        cmp es:[si],byte ptr 0
                        je  l6
                        inc si
                        jmp l5
l6:
                        inc si
                        jmp l7
Get_Dos_Var             ENDp

program                 proc
                        push es
                        push dx                                         ; offset naam bewaren
                        mov dx,es:[2ch]                                 ; ES = Program Segment Prefix
                        mov es,dx                                       ; ES = Environment Space
                        mov bx,0
pl1:
                        cmp es:[bx],word ptr 0
                        je  gevonden
                        inc bx
                        jmp pl1
gevonden:
                        pop di                                          ; offset naam terug opvragen
                        add bx,4
                        push ds                                         ;               *3
                        push ds                                         ;       *2
                        mov si,bx
                        push es                                         ; *1
                        pop  ds                                         ; *1
                        pop  es                                         ;       *2
                        mov cx,40h
                        rep movsw
                        pop  ds                                         ;               *3
                        pop  es
                        ret
program                 endp

parameter               proc
                        mov bx,@para_read
@spcinc:                mov dl,es:[bx]
                        inc bx
                        cmp dl,32
                        je  @spcinc
                        dec bx
@lusinc:                mov dl,es:[bx]
                        cmp dl,13
                        je  @eindinc
                        cmp dl,32
                        je  @eindinc
                        xchg bx,ax
                        mov ds:[bx],dl
                        xchg bx,ax
                        inc bx
                        inc ax
                        jmp @lusinc
@eindinc:               mov word ptr @para_read,bx
                        xor dl,dl
                        mov bx,ax
                        mov ds:[bx],dl
                        ret
parameter               endp

.data
PUBLIC                  s_side
PUBLIC                  s_spoor
PUBLIC                  s_drive
PUBLIC                  s_sector
PUBLIC                  s_aantal
PUBLIC                  s_tekst

@para_read              dw      0081h                                   ; Command-Lijn parameter begint op 0081H .....
s_side                  db      0
s_spoor                 db      0
s_drive                 db      0
s_sector                db      0
s_aantal                db      0
s_tekst                 dw      0000h

de_waarde               dw      0
Naam                    dw      0
Input                   dw      0
Buffer                  db      80 dup (0)
Vlag                    dw      0

EXEC_ERROR              dw 0
keep_ss                 dw 0                                            ; Bewaren van bepaalde registers
keep_sp                 dw 0
keep_es                 dw 0
parmblk                 dw 0                                            ; Exec parameter blok (Zie Boven)
                        dd 0
                        dd 0
                        dd 0

                        end
